
from qt import *

class QSyncer(QObject):
    def __init__(self, s1, s2):
        QObject.__init__(self)
        self._s1 = s1
        self._s2 = s2
        self.connect(s1, SIGNAL("contentsMoving(int, int)"), self.moving1)
        self.connect(s2, SIGNAL("contentsMoving(int, int)"), self.moving2)

    def moving1(self, x, y):
        print "moving1"
        _s2 = self._s2
        blocked = _s2.signalsBlocked()
        _s2.blockSignals(1)
        _s2.setContentsPos(_s2.contentsX(), y)
        _s2.blockSignals(blocked)

    def moving2(self, x, y):
        print "moving2"
        _s1 = self._s1
        blocked = _s1.signalsBlocked()
        _s1.blockSignals(1)
        _s1.setContentsPos(_s1.contentsX(), y)
        _s1.blockSignals(blocked)


if __name__=="__main__":
    import sys
    app = QApplication(sys.argv)
    box = QHBox()
    app.setMainWidget(box)
    list1 = QListView(box)
    list1.addColumn("Foo")
    list2 = QListView(box)
    list2.addColumn("Bar")
    for i in range(20):
        s = QString("Item #%d for list 1" % i)
        QListViewItem(list1, s)
        s = QString("Item #%d for list 2" % i)
        QListViewItem(list2, s)
    QSyncer(list1, list2)
    box.show()
    app.exec_loop()

